//-------------------------------------------------------------------
//	File:		CHair.cpp
//	Created:	13/06/00 19:30:PM
//	Author:		Allard Jeremie ( Hufo / N.A.A. )
//	Comments:	Create and manage Hairs.
//-------------------------------------------------------------------
#include "stdafx.h"
//#include "Texture.h"
#include "CHair.h"
#include <stdio.h>

void CLine::Init(CPoint3D p0, CPoint3D dp)
{
  pt0=p0;
  pt1=p0+dp;
  pta=pt1;
}

void CHair::Init(CObject *_o,CSurface *_s)
{
  nbl=NBHAIR;
	o=_o; s=_s;
	m=*s;
	m.flag&=~CMaterial::Lighting;
	for (int i=0;i<NBHAIR;i++)
	{
		int f=rnd(s->nbf);
		CTriFace *fc=s->fc+f;
		float a=rnd(1.0f);
		float b=rnd(1.0f);
		if (a+b>1.0f)
		{
			a=1.0f-a;
			b=1.0f-b;
		}
		CPoint3D pos=fc->v[0]->p + a*(fc->v[1]->p - fc->v[0]->p) + b*(fc->v[2]->p - fc->v[0]->p);
		CPoint3D dir=fc->v[0]->n + a*(fc->v[1]->n - fc->v[0]->n) + b*(fc->v[2]->n - fc->v[0]->n);
		dir.Scale(HAIRLENGTH/dir.Length());
		ln[i].Init(pos,dir);
	}
	{
	CColor4f col=m.diffuse;
	for (int i=0;i<HAIRNCOLOR;i++)
	{
		c[i]=col*((i+HAIRNCOLOR/2)*1.0f/HAIRNCOLOR);
	}
	}
}

inline void glVertex3D(const CPoint3D &p)
{
  glVertex3f(p.x,p.y,p.z);
}

extern float fps;

void CHair::Aff()
{
	int pdata=m.Put();
	CLine *l=ln;
	int n; //=NBHAIR;
  //glColor4fv(c[0].t);
  glBegin(GL_LINES);
  for (int ic=0;ic<HAIRNCOLOR;ic++)
  {
		glColor4fv(c[ic].t);
    if (ic==HAIRNCOLOR-1) n=nbl-(HAIRNCOLOR-1)*(nbl/HAIRNCOLOR);
    else n=nbl/HAIRNCOLOR;

	//glInterleavedArrays(GL_V3F,16,l);
	//glDrawArrays(GL_LINES,0,2*n);
  //l+=n;
    CPoint3D p;
	  do
	  {
      //p.x=(l->pt0.x+l->pta.x)*0.5f;
      //p.y=(l->pt0.y+l->pta.y)*0.5f;
      //p.z=(l->pt0.z+l->pta.z)*0.5f;
      glVertex3D(l->pt0);
      ////glVertex3D(l->pta);
      //glVertex3D(p);
      //glVertex3D(p);
      glVertex3D(l->pt1);
		  ++l;
	  }
	  while (--n);

  }
  glEnd();
}

void CHair::Update(float dt,CPoint3D Depl)
{
  if (dt>0)
    Depl.Scale(1.0f/dt);
  float f=(float)pow(0.1f,dt);
  Depl0=Depl0*f+Depl*(1.0f-f);
  Depl=Depl0;
  int i=nbl;
  CLine *pl=ln;
  Depl.Scale(HAIRLENGTH*4);
  do
  {
    pl->pt1.x=pl->pta.x+Depl.x;
    pl->pt1.y=pl->pta.y+Depl.y;
    pl->pt1.z=pl->pta.z+Depl.z;
    //pl->pt1.Scale(HAIRLENGTH/pl->pt1.Length());
    ++pl;
  }
  while (--i);
}

void CHair::CurrentFPS(float fps)
{
  nbl=int(nbl*(fps/20.0f));
  if (nbl<NBHAIR/10) nbl=NBHAIR/10;
  if (nbl>NBHAIR) nbl=NBHAIR;
}
